package com.link.core.util;

import com.link.base.user.model.CoreUser;
import org.apache.ibatis.javassist.Modifier;
import org.springframework.stereotype.Service;

public class MultiCorpUtil {
   public static Object getCorpServiceBean(Class serviceClass) throws Exception {
      CoreUser user = UserUtil.getUser();
      if (user == null) {
         return null;
      } else {
         Long corpId = user.getLoginCorpId();
         return getCorpServiceBean(serviceClass, corpId);
      }
   }

   public static Object getCorpServiceBean(Class serviceClass, Long corpId) throws Exception {
      String serviceSymbol = "Service";
      String standardBeanName = null;
      if (null == corpId) {
         return null;
      } else {
         Service annotation = (Service)serviceClass.getClass().getAnnotation(Service.class);
         if (annotation != null) {
            standardBeanName = annotation.value();
         } else if (Modifier.isInterface(serviceClass.getModifiers())) {
            standardBeanName = StringUtils.firstCharLowerCase(serviceClass.getSimpleName());
         }

         if (StringUtils.isBlank(standardBeanName)) {
            return null;
         } else {
            StringBuilder sb = new StringBuilder(standardBeanName);
            if (standardBeanName != null && standardBeanName.endsWith("Service")) {
               sb.insert(sb.lastIndexOf("Service"), "C" + corpId);
            }

            String corpBeanName = sb.toString();
            Object corpService = BeanTools.getBean(corpBeanName);
            return corpService;
         }
      }
   }
}
